#!/usr/bin/env bash
source <(curl -fsSL https://raw.githubusercontent.com/community-scripts/ProxmoxVE/main/misc/build.func)
# Copyright (c) 2021-2025 community-scripts ORG
# Author: GitHub Copilot
# License: MIT | https://github.com/community-scripts/ProxmoxVE/raw/main/LICENSE
# Source: https://github.com/vogler/free-games-claimer

APP="free-games-claimer"
var_tags="${var_tags:-gaming;utility}"
var_cpu="${var_cpu:-2}"
var_ram="${var_ram:-2048}"
var_disk="${var_disk:-8}"
var_os="${var_os:-debian}"
var_version="${var_version:-12}"
var_unprivileged="${var_unprivileged:-1}"

header_info "$APP"
variables
color
catch_errors

function update_script() {
    header_info
    check_container_storage
    check_container_resources

    if [[ ! -d /opt/${APP} ]]; then
        msg_error "No ${APP} Installation Found!"
        exit
    fi

    msg_info "Checking for updates"
    cd /opt/${APP} || exit
    RELEASE=$(curl -fsSL https://api.github.com/repos/vogler/free-games-claimer/releases/latest | grep "tag_name" | awk '{print substr($2, 3, length($2)-4)}')

    if [[ -f /opt/${APP}_version.txt ]] && [[ "${RELEASE}" == "$(cat /opt/${APP}_version.txt)" ]]; then
        msg_ok "No update required. ${APP} is already at v${RELEASE}"
        exit
    fi

    msg_info "Stopping ${APP}"
    systemctl stop ${APP}
    msg_ok "Stopped ${APP}"

    msg_info "Creating Backup"
    if ls /opt/"${APP}"_backup_*.tar.gz &>/dev/null; then
        rm -f /opt/"${APP}"_backup_*.tar.gz
        msg_info "Removed previous backup"
    fi
    tar -czf "/opt/${APP}_backup_$(date +%F).tar.gz" /opt/"${APP}"
    msg_ok "Backup Created"

    msg_info "Updating ${APP} to v${RELEASE}"
    cd /opt/${APP} || exit
    git pull
    npm install
    msg_ok "Updated ${APP} to v${RELEASE}"

    msg_info "Starting ${APP}"
    systemctl start ${APP}
    msg_ok "Started ${APP}"

    msg_info "Cleaning Up"
    npm cache clean --force
    msg_ok "Cleanup Completed"

    echo "${RELEASE}" >/opt/${APP}_version.txt
    msg_ok "Update Successful"
    exit
}

start
build_container
description

msg_ok "Completed Successfully!\n"
echo -e "${CREATING}${GN}${APP} setup has been successfully initialized!${CL}"
echo -e "${INFO}${YW} Access it using the following URL:${CL}"
echo -e "${TAB}${GATEWAY}${BGN}http://${IP}:6080${CL}"
echo -e "${INFO}${YW} Or use a VNC client to connect to:${CL}"
echo -e "${TAB}${GATEWAY}${BGN}${IP}:5900${CL}"
